package com.loafle.overflow.probe.container.crawler;

import com.fasterxml.jackson.databind.ObjectMapper;
import com.loafle.overflow.probe.container.crawler.config.Config;
import com.loafle.overflow.probe.container.crawler.result.ResultSet;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

public abstract class Crawler {
    protected ObjectMapper objectMapper;
    private Map<String,Config> configs;
    private String configPath;

    protected Crawler() {
        objectMapper = new ObjectMapper();
    }

    public Config getConfig(String id) throws Exception {
        return configs.get(id);
    }

    public void putConfig(String id, Config config) throws Exception {
        if (configs == null) {
            configs = new HashMap<>();
        }
        configs.put(id, config);
    }

    public boolean add(Config config) throws Exception {
        this.putConfig(config.getId(), config);
        return true;
    }

    public Map<String, String> get(String id) throws Exception {

        List<ResultSet> rsList =  (List<ResultSet>)getInternal(getConfig(id));
        Map<String, String> rm = new HashMap<>();
        Map<String, String> m = null;

        for (ResultSet rs : rsList) {
            m =  rs.getData();
            rm.putAll(m);
        }

        return rm;
    }

    public boolean init(Config config) throws Exception {
        add(config);
        return true;
    }

    public boolean remove(String id) throws Exception {
        this.configs.remove(id);
        return true;
    }

    public abstract String name();
    public abstract List<ResultSet> getInternal(Config c) throws Exception;

    public Object getInternalMeta(Config c) throws Exception {
        return null;
    }
}

