package com.loafle.overflow.probe.container.crawler.impl.wmi;

import com.loafle.overflow.probe.container.crawler.Crawler;
import com.loafle.overflow.probe.container.crawler.config.Config;
import com.loafle.overflow.probe.container.crawler.result.ResultSet;

import java.io.File;
import java.io.IOException;
import java.net.URL;
import java.util.ArrayList;
import java.util.List;

public class WMICrawler extends Crawler {
    public String name() {
        return "WMI_CRAWLER";
    }

    @Override
    public List<ResultSet> getInternal(Config config) throws Exception {

        return WMICrawlerOS.getInstance().process(config);
    }

    @Override
    public Object getInternalMeta(Config c) throws Exception {

        List<Config> metaConfigList = loadMetaConfig();


        List<ResultSet> retlist = new ArrayList<>();
        WMICrawlerOS os = WMICrawlerOS.getInstance();
        ResultSet ofResultSet = null;
        for(Config metaConfig : metaConfigList) {

            for(int indexI = 0; indexI < metaConfig.getItems().size(); ++indexI) {
                ofResultSet = os.processWMI(c, metaConfig.getItems().get(indexI));
                if(ofResultSet != null) {
                    retlist.add(ofResultSet);
                }
            }
        }

        return null;
    }


    private List<Config> loadMetaConfig() throws IOException {
        ClassLoader classLoader = getClass().getClassLoader();

        URL url = classLoader.getResource("config/wmi/meta");
        if(url == null) {
            return null;
        }

        String path = url.getFile();

        File pathFile = new File(path);

        System.out.println(path);
        String[] metaFiles = pathFile.list();
        List<Config> retList = new ArrayList<>();
        Config metaConfig = null;
        for(String fi : metaFiles) {
            if(fi.indexOf("meta_") > -1) {
                metaConfig = objectMapper.readValue(new File(path+"/"+fi), Config.class);
                if(metaConfig != null) {
                    retList.add(metaConfig);
                }
            }
        }

        return retList;
    }
}
