package com.loafle.overflow.probe.container.crawler.impl.wmi;

import com.loafle.overflow.probe.container.crawler.config.Config;
import com.loafle.overflow.probe.container.crawler.config.Item;
import com.loafle.overflow.probe.container.crawler.result.ResultSet;

import java.util.ArrayList;
import java.util.List;

public abstract class WMICrawlerOS {

    private static WMICrawlerOS wmiCrawlerOS = null;

    public static WMICrawlerOS getInstance() {

        if(WMICrawlerOS.wmiCrawlerOS == null) {

            String os = System.getProperty("os.name").toLowerCase();

            if(os.indexOf("linux") >= 0) {
                WMICrawlerOS.wmiCrawlerOS = new WMICrawlerLinux();
            } else if(os.indexOf("") >= 0) {
                WMICrawlerOS.wmiCrawlerOS = new WMICrawlerWindows();
            }

        }

        return WMICrawlerOS.wmiCrawlerOS;
    }

    public List<ResultSet> process(Config config)  throws Exception {

        List<ResultSet> retlist = new ArrayList<>();
        ResultSet ofResultSet = null;
        for(int cIndexI = 0 ; cIndexI < config.getItems().size() ; ++cIndexI) {

            ofResultSet = processWMI(config, config.getItems().get(cIndexI));
            retlist.add(ofResultSet);
        }


        return retlist;
    }

    public abstract ResultSet processWMI(Config config, Item item) throws Exception ;
}

