package com.loafle.overflow.probe.container.crawler.result;

import com.loafle.overflow.probe.container.crawler.config.Item;
import com.loafle.overflow.probe.container.crawler.config.MappingInfo;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;

public abstract class ResultSet {
    // properties
    protected Item item;
    protected List<List<String>> rows;
    protected Map<String, Integer> meta = null;

    public Map<String, Integer> getMeta() {
        return meta;
    }

    public void setMeta(Map<String, Integer> meta) {
        this.meta = meta;
    }

    public List<List<String>> getRows() {
        return rows;
    }

    public void setRows(List<List<String>> rows) {
        this.rows = rows;
    }

    public Item getItem() {
        return item;
    }

    public void setItem(Item item) {
        this.item = item;
    }

    // methods
    static public ResultSet newInstance(Item item) {
        if (item.getMappingInfo() == null) {
            item.setMappingInfo(new MappingInfo());
        }
        String type = (String) item.getMappingInfo().getParseDirection();
        if (type != null && type.equals("row")) {
            return new ResultSetRow(item);
        } else {
            return new ResultSetCol(item);
        }
    }


    public ResultSet(Item item) {
        this.item = item;
        this.rows = new ArrayList<>();
        this.setMeta();
    }

    public void addRow(List<String> row) {
        rows.add(row);
    }


    public Map<String,String> getData() {
        return parse();
    }

    // abstracts
    public abstract void setMeta();
    public abstract Map<String, String> parse();


}

