package com.loafle.overflow.probe.container.crawler.result;

import com.loafle.overflow.probe.container.crawler.config.Item;
import com.loafle.overflow.probe.container.crawler.config.Keys;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class ResultSetRow extends ResultSet{

    public ResultSetRow(Item item) {
        super(item);
    }

    public void setMeta() {

        List<String> meta = new ArrayList<>();

        List<String> arrayColumns = (List<String>) this.item.getMappingInfo().getArrayColumns();
        List<String> keyColumns = (List<String>) this.item.getMappingInfo().getKeyColumns();
        String valueColumn = (String) this.item.getMappingInfo().getValueColumn();
        if (arrayColumns != null) {
            for (String c : arrayColumns) {
                meta.add(c);
            }
        }

        if (keyColumns != null) {
            for (String c: keyColumns) {
                meta.add(c);
            }
        }

        if (valueColumn != null && !valueColumn.equals(""))
            meta.add(valueColumn);

        if(this.meta == null) {
            this.meta = new HashMap<>();
        }

        for(int indexI = 0; indexI < meta.size(); ++indexI) {
            this.meta.put(meta.get(indexI), indexI);
        }

    }

    public Map<String, String> parse() {

        Map<String, String> returnMap = new HashMap<>();

        String valueColumn = (String) this.item.getMappingInfo().getValueColumn();

        for (List<String> row : this.rows) {
            String key = makeKey(row);
            if(key == null) continue;
            returnMap.put(key,row.get(this.meta.get(valueColumn)));
        }

        return returnMap;
    }

    private String makeKey(List<String> data) {

        List<Keys> metrics = this.item.getKeys();

        List<String> arrayColumns = (List<String>) this.item.getMappingInfo().getArrayColumns();
        List<String> keyColumns = (List<String>) this.item.getMappingInfo().getKeyColumns();
        List<Keys> keys = this.item.getKeys();

        boolean find = false;
        int findIndex = -1;
        for (String keyColumn: keyColumns) {
            String row = data.get(this.meta.get(keyColumn));
            for (int i =0 ; i < keys.size() ; ++i) {
                if (row.equals(keys.get(i).getKey())) {
                    findIndex = i;
                    find = true;
                    break;
                }
            }
            if (find == true) {break;}
        }

        if(findIndex < 0) {
            return null;
        }

        String metric = metrics.get(findIndex).getMetric();

        if (arrayColumns != null) {
            for (int  i =0 ; i< arrayColumns.size() ; ++i) {
                // replace
                String k = "$" + i;
                int dataIndex = this.meta.get(arrayColumns.get(i));
                String replaceString = data.get(dataIndex);
                metric = metric.replace(k,"'" + replaceString + "'");
            }
        }
        return metric;
    }

}
