package com.loafle.overflow.probe.container.server;

import io.netty.channel.Channel;
import io.netty.channel.ChannelInitializer;
import io.netty.channel.ChannelPipeline;
import io.netty.handler.codec.json.JsonObjectDecoder;
import io.netty.handler.codec.string.StringDecoder;
import io.netty.handler.codec.string.StringEncoder;
import io.netty.util.CharsetUtil;

public class ContainerChannelInitializer extends ChannelInitializer<Channel> {
    private static final StringDecoder STRING_DECODER = new StringDecoder(CharsetUtil.UTF_8);
    private static final StringEncoder STRING_ENCODER = new StringEncoder(CharsetUtil.UTF_8);


    @Override
    protected void initChannel(Channel channel) throws Exception {
        ChannelPipeline channelPipeline = channel.pipeline();

        channelPipeline
                .addLast(new JsonObjectDecoder(Integer.MAX_VALUE))
                .addLast(STRING_DECODER)
                .addLast(STRING_ENCODER)
                .addLast(ContainerConfiguration.channelInboundHandlerAdapter());

    }
}
