package com.loafle.overflow.probe.container.service;

import com.loafle.overflow.probe.container.crawler.Crawler;
import com.loafle.overflow.probe.container.crawler.config.Config;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;

public class ConfigService extends Service {
    public ConfigService(Map<String, Crawler> crawlers) {
        super(crawlers);
    }

    public boolean init(List<Map<String, Config>> configs) throws Exception {
        Crawler crawler;
        Config config;

        boolean ok = true;
        List<Map.Entry<String, Config>> sensorIDs = new ArrayList<>();

        Loop:
        for (Map<String, Config> item : configs) {
            for (Map.Entry<String, Config> entry : item.entrySet()) {
                crawler = getCrawler(entry.getKey());
                ok = crawler.init(entry.getValue());
                if (!ok) {
                    break Loop;
                }
                sensorIDs.add(entry);
            }
        }

        if (!ok) {
            for (Map.Entry<String, Config> entry : sensorIDs) {
                remove(entry.getKey(), entry.getValue().getId());
            }
            return false;
        }

        return true;
    }

    public boolean add(String crawlerName, Config config) throws Exception {
        Crawler crawler = getCrawler(crawlerName);
        return crawler.add(config);
    }

    public boolean remove(String crawlerName, String id) throws Exception {
        Crawler crawler = getCrawler(crawlerName);
        return crawler.remove(id);
    }
}
