package com.loafle.overflow.probe.container.service;

import com.loafle.overflow.probe.container.crawler.Crawler;

import java.util.Map;

public abstract class Service {
    private Map<String, Crawler> crawlers;
    protected Service(Map<String, Crawler> crawlers) {
        this.crawlers = crawlers;
    }

    protected Crawler getCrawler(String crawlerName) throws Exception {
        if (!this.crawlers.containsKey(crawlerName)) {
            throw new Exception(String.format("Container: Crawler[%s] is not exist", crawlerName));
        }
        return this.crawlers.get(crawlerName);
    }
}
