package com.loafle.overflow.probe.container.crawler.impl.snmp;

import com.fasterxml.jackson.databind.ObjectMapper;
import com.loafle.overflow.probe.container.crawler.CrawlerTest;
import com.loafle.overflow.probe.container.crawler.config.Config;
import com.loafle.overflow.probe.container.crawler.result.ResultSet;
import org.junit.Ignore;
import org.junit.Test;

import java.io.File;
import java.util.List;
import java.util.Map;

import static org.junit.Assert.*;

public class SNMPCrawlerTest extends CrawlerTest {
    /***
     * v2c test info
     * private static String addr = "192.168.1.215";
     * private static String port = "161";
     *  private static String community = "public";
     *
     * v3 test info
     * loafle MD5 "qwer5795" DES "qweqwe123" : AUTHPRIV
     * loafle2 SHA "qwer5795" AES "qweqwe123" : AUTHPRIV
     * loafle3 MD5 "qwer5795" : AUTHNOPRIV
     * loafle4 :NOAUTHNOPRIV
     */

    @Ignore
    @Test
    public void testSNMP3() throws Exception {
        SNMPCrawler c = new SNMPCrawler();
        ClassLoader classLoader = getClass().getClassLoader();
        String p =  classLoader.getResource("config/snmp/examplev3.json").getFile();
        Config config = objectMapper.readValue(new File(p),Config.class);

        Object result = c.getInternal(config);

        if(result instanceof Boolean) {
            System.out.println("validate : " + result);
        }else  {
            printResult((List<ResultSet>)result);
        }

    }

    @Ignore
    @Test
    public void testSNMP2c() throws Exception {
        SNMPCrawler c = new SNMPCrawler();

        ClassLoader classLoader = getClass().getClassLoader();
        String p =  classLoader.getResource("config/snmp/examplev2.json").getFile();
        Config config = objectMapper.readValue(new File(p),Config.class);

        Object result = c.getInternal(config);

        if(result instanceof Boolean) {
            System.out.println("validate : " + result);
        }else  {
            printResult((List<ResultSet>)result);
        }

    }

    private void printResult(List<ResultSet> resultList) {
        for(int indexI = 0 ; indexI < resultList.size(); ++indexI) {
            Map<String,String> resultMap = resultList.get(indexI).getData();
            System.out.println("============================================");
            for( String key : resultMap.keySet() ){
                System.out.println( String.format("key : %s ||| value : %s", key, resultMap.get(key)) );
            }
            System.out.println("============================================");
        }

    }

}