package com.loafle.overflow.probe.container.crawler.impl.wmi;

import com.fasterxml.jackson.databind.ObjectMapper;
import com.loafle.overflow.probe.container.crawler.CrawlerTest;
import com.loafle.overflow.probe.container.crawler.config.Config;
import com.loafle.overflow.probe.container.crawler.result.ResultSet;
import org.junit.After;
import org.junit.Before;
import org.junit.Ignore;
import org.junit.Test;

import java.io.File;
import java.io.IOException;
import java.net.URL;
import java.util.*;

import static org.junit.Assert.*;

public class WMICrawlerTest extends CrawlerTest {
    @Before
    public void setUp() throws Exception {

    }

    @After
    public void tearDown() throws Exception {

    }


    @Ignore
    @Test
    public void testLinuxExe() throws Exception {

        String command = "/home/snoop/temp/wmic";

        ProcessBuilder builder = new ProcessBuilder(command, "-U","administrator%dbseogns18", "//192.168.1.106", "SELECT Caption FROM Win32_LogicalDisk", "--namespace=root/cimv2", "--delimiter=||");
        Process process = builder.start();

        byte[] msg = new byte[1024];

        StringBuffer buf = new StringBuffer();

        while(process.getInputStream().read(msg) > 0) {
            buf.append(new String(msg));
            Arrays.fill(msg, (byte)0);
        }

        System.out.println(buf.toString());
    }

    @Test
    public void testWMI() throws Exception {
        WMICrawler wmiCrawler = new WMICrawler();

        Map<String, Object> map = new HashMap<String, Object>();

//        String id = "administrator";
//        String pw = "!@#$qwer1234";
//        String nameSpace = "root/cimv2";
//        String query = "select * from Win32_OperatingSystem";
//        String ip = "192.168.1.1";

//        map.put("id", "administrator");
//        map.put("pw", "!@#$qwer1234");
//        map.put("nameSpace", "root/cimv2");
//        map.put("query", "select * from Win32_OperatingSystem");
//        map.put("ip", "192.168.1.1");

        Config config = new Config();

        ClassLoader classLoader = getClass().getClassLoader();

        String s =  classLoader.getResource("config/wmi").getFile();
        System.out.println(s);

//        Config c = mapper.readValue(new File(classLoader.getResource("config").getFile()),Config.class);


//        List<Map<String, String>> resultList =  (List<Map<String, String>>)wmiCrawler.getInternal(map);
//
//
//        for( Map<String,String> rMap : resultList) {
//            for( String key : rMap.keySet() ){
//                System.out.println( String.format("key : %s ||| value : %s", key, rMap.get(key)) );
//            }
//        }


    }

    @Test
    public void testOS() {
        System.out.println(System.getProperty("os.name"));

    }

    @Ignore
    @Test
    public void testConfig() throws IOException {
        ClassLoader classLoader = getClass().getClassLoader();
        String p =  classLoader.getResource("config/wmi/example.json").getFile();

        System.out.println(p);


        Config c = objectMapper.readValue(new File(p),Config.class);

        System.out.println(c);
    }

    @Ignore
    @Test
    public void testWMIJson() throws Exception {
        ClassLoader classLoader = getClass().getClassLoader();
        String p =  classLoader.getResource("config/wmi/meta/meta_network.json").getFile();
        Config c = objectMapper.readValue(new File(p),Config.class);

//        Map<String, Object> map = new HashMap<>();
//        map.put("id", "administrator");
//        map.put("pw", "!@#$qwer1234");

//        c.getTarget().setAuth(map);

//        c.getTarget().getAuth().put("id", "administrator");
//        c.getTarget().getAuth().put("pw", "!@#$qwer1234");


        WMICrawler wmiCrawler = new WMICrawler();


        List<ResultSet> resultList =  (List<ResultSet>)wmiCrawler.getInternal(c);

        PrintResultList(resultList);
//        for(int indexI = 0 ; indexI < resultList.size(); ++indexI) {
//            Map<String,String> resultMap = resultList.get(indexI).getData();
//            System.out.println("============================================");
//            for( String key : resultMap.keySet() ){
//                System.out.println( String.format("key : %s ||| value : %s", key, resultMap.get(key)) );
//            }
//            System.out.println("============================================");
//        }





    }

    public void PrintResultList(List<ResultSet> resultList) {
        for(int indexI = 0 ; indexI < resultList.size(); ++indexI) {
            Map<String,String> resultMap = resultList.get(indexI).getData();
            System.out.println("============================================");
            for( String key : resultMap.keySet() ){
                System.out.println( String.format("key : %s ||| value : %s", key, resultMap.get(key)) );
            }
            System.out.println("============================================");
        }
    }

    @Ignore
    @Test
    public void testMetaProcess() throws Exception {

        // get targetinfo
        ClassLoader classLoader = getClass().getClassLoader();
        String p =  classLoader.getResource("config/wmi/test.json").getFile();
        Config c = objectMapper.readValue(new File(p),Config.class);

        List<Config> metaConfigList = loadMetaConfig();


        List<ResultSet> retlist = new ArrayList<>();
        WMICrawlerOS os = WMICrawlerOS.getInstance();
        ResultSet ofResultSet = null;
        for(Config metaConfig : metaConfigList) {

            for(int indexI = 0; indexI < metaConfig.getItems().size(); ++indexI) {
                ofResultSet = os.processWMI(c, metaConfig.getItems().get(indexI));
                if(ofResultSet != null) {
                    retlist.add(ofResultSet);
                }
            }
        }





        PrintResultList(retlist);

    }

    public List<Config> loadMetaConfig() throws IOException {
        ClassLoader classLoader = getClass().getClassLoader();

        URL url = classLoader.getResource("config/wmi/meta");
        if(url == null) {
            return null;
        }

        String path = url.getFile();

        File pathFile = new File(path);

        System.out.println(path);
        String[] metaFiles = pathFile.list();
        List<Config> retList = new ArrayList<>();
        Config metaConfig = null;
        for(String fi : metaFiles) {
            if(fi.indexOf("meta_") > -1) {
                metaConfig = objectMapper.readValue(new File(path+"/"+fi), Config.class);
                if(metaConfig != null) {
                    retList.add(metaConfig);
                }
            }
        }

        return retList;
    }

    @Test
    public void testInt() {

        Integer a = 1;

        aaa(a);

        System.out.println(a);

    }

    public void aaa(Integer a) {
        ++a;

    }

    @Test
    public void testString() {

        String str = "cpu[].usage.system";

        int idx = str.indexOf("[");
        int arrIdx = 0;

        String ret = "";
        ret += str.substring(0, idx +1);
        ret += String.valueOf(arrIdx);
        ret += str.substring(idx +1);

        System.out.println(ret);

    }

    @Test
    public void testReplace() {


        String aaa = "cpu[$0].usage.system";

        String bbb = "$";
        String ccc = bbb + String.valueOf(0);

        String ddd = aaa.replace(ccc, "asdfasdf");


        System.out.println(ddd);



    }

    @Test
    public void testMap() {


        Map<String, String> aa = new HashMap<>();

        aa.put("111", "123123123");
        aa.put("222", "123123123");

        Map<String, String> bb = new HashMap<>();


        bb.put("333", "123123123");
        bb.put("444", "123123123");


        aa.putAll(bb);

        for( String key : aa.keySet() ){
            System.out.println( String.format("key : %s ||| value : %s", key, aa.get(key)) );
        }


    }

    @Test
    public void testRes() throws IOException {
        ClassLoader classLoader = getClass().getClassLoader();

        URL url = classLoader.getResource("config/wmi/meta");


        File file = new File(url.getFile());

        String[] fl = file.list();

        for(String f : fl) {
            System.out.println(f);
        }


    }

}
